Skip to content

HTTPS clone URL

Subversion checkout URL

You can clone with HTTPS or Subversion.

Download ZIP
Tools for scientific computation in Ruby/Rails
R Ruby
tree: 5bcc24917d

Fetching latest commit…

Cannot retrieve the latest commit at this time

Failed to load latest commit information.
bin
data/r/man
lib
samples
spec
static
test
.autotest
.gitignore
.rspec
Gemfile
History.txt
LICENSE.txt
Manifest.txt
README.rdoc
Rakefile
sciruby.gemspec

README.rdoc

SciRuby

Tools for Scientific Computing in Ruby

Description

Ruby has for some time had no equivalent to the beautifully constructed numpy, scipy, and matplotlib libraries for Python. We believe that the time for a Ruby science and visualization package has come and gone. Sometimes when a solution of sugar and water becomes super-saturated, from it precipitates a pure, delicious, and diabetes-inducing crystal of sweetness, induced by no more than the tap of a finger. So it is, we believe, with the need for numeric and visualization libraries in Ruby.

We are not the first with this idea, but we are trying to bring it to life.

WARNING:

Please be aware that SciRuby is in PRE-ALPHA status. If you're thinking of using SciRuby to write mission critical code, such as for driving a car or flying a space shuttle, you may wish to choose other software (for now).

Features

  • SciRuby::Plotter - visualization GUI for updating plots as scripts are modified

  • SciRuby::Editor - code editor for modifying rubyvis plot scripts

  • Rubyvis - Protovis plotting in Ruby

  • Statsample - a suite for basic and advanced statistics in Ruby

  • SciRuby::Analysis - domain-specific language (DSL) for hassle-free statistical analysis (originally from Statsample)

  • Minimization algorithms in pure Ruby and using GSL

  • Numeric integration algorithms

Planned Features

  • Numarray rewrite, including sparse matrices.

SYNOPSIS:

From the command line,

sciruby-plotter my_plot.rb

Or, inside a Ruby shell,

$ require 'sciruby'

REQUIREMENTS:

  • statsample (and optionally statsample-optimization)

  • distribution

  • rubyvis

  • narray

  • minimization

  • integration

  • green_shoes

INSTALLATION:

gem install sciruby

You'll also want to make sure you install the headers for the GUI. If you're using Ubuntu:

sudo apt-get install libgtk2.0-dev libgtksourceview2.0-dev librsvg2-dev libcairo2-dev

You can also optionally get rb-gsl, statistics2, and other useful architecture-specific packages using

gem install statsample-optimization

Note that as of this writing, rb-gsl is incompatible with the 1.15 version of the GSL headers. You should make sure you're using the 1.14 headers.

More detailed installation instructions are available at here

DEVELOPERS:

Before commiting any code, you MUST read our Contributor Agreement.

After checking out the source, run:

$ bundle exec rake newb
$ bundle install

This task will install any missing dependencies, run the tests/specs, and generate the RDoc.

NOTE: Don't despair if `rake newb` doesn't work for you. We're still working out the kinks.

LICENSE:

Copyright © 2010 - 2011, The Ruby Science Foundation.

All rights reserved.

SciRuby is licensed under the BSD 2-clause license. See LICENSE.txt for details.

DONATIONS:

Something went wrong with that request. Please try again.